<?php
namespace FM\Controller;

use FM\Controller\FMCrud;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DataSource\DataSet;
use FM\Service\EscoposTarefaService;

class EscoposTarefaController extends FMCrud{
    protected $EscoposTarefaService;
   
    public function __construct($crudService, $environment, EscoposTarefaService $EscoposTarefaService) {
        parent::__construct($crudService, $environment);
        $this->EscoposTarefaService = $EscoposTarefaService;
    }

    public function SaveEscopoServico(DTO\Request $request, DTO\Response $response){
        $params = $request->getParameters();
        $var = $this->EscoposTarefaService->SaveEscopoServico($params);
        $dtsVal = new DataSet("situation", [$var]);
        $response->addDataSet($dtsVal);
    }
    
    public function getEscopoServico(DTO\Request $request, DTO\Response $response){
        $var = $this->EscoposTarefaService->getEscopoServico();
        $dtsVal = new DataSet("dataEscopo", $var);
        $response->addDataSet($dtsVal);
    }
}

?>