<?php
namespace FM\Service;

use FM\Factory\EscoposTarefaFactory;
use Teknisa\Libs\Util\Environment;
use Teknisa\Libs\Util\NewCode;
use Doctrine\ORM\EntityManager;

class EscoposTarefaService {

    protected $EscoposTarefaFactory;
    protected $Environment;
    protected $newCode;
    protected $connection;

    public function __construct (EscoposTarefaFactory $EscoposTarefaFactory, Environment $Environment, NewCode $newCode, EntityManager $entityManager) {
        $this->EscoposTarefaFactory         = $EscoposTarefaFactory;
        $this->Environment                  = $Environment;
        $this->newCode                      = $newCode;
        $this->connection                   = $entityManager->getConnection(); 
    }

    public function SaveEscopoServico($valuesFront) {
      $this->connection->beginTransaction();
      
      try {
        $datas = array(
          'NRESCOPOSTAREFA' => $this->newCode->getCodeByTableName('FCM_ESCOPOSTAREFA', 20, 1, 10, true),
          'NMESCOPOSTAREFA' => $valuesFront['NAME'],
          'NRORG' => 20,
          'CDOPERINCLUSAO' => null,
          'NRORGINCLUSAO' => null,
          'CDOPERULTATU' => null,
          'NRORGULTATU' => null
        );
        $this->EscoposTarefaFactory->SaveEscopoServico($datas);
        
        $this->connection->commit();
        $response = "OK";
      } catch (\Exception $e) {
        $this->connection->rollback();
        $response = $e->getMessage();
      }

      return $response;
    }

    public function getEscopoServico() {
      $response = $this->EscoposTarefaFactory->getEscopoServico();
      return $response;
    }
}