<?php
namespace FM\Service;

use FM\Factory\NewLocalAtendimentoFactory;
use Teknisa\Libs\Util\Environment;
use Teknisa\Libs\Util\NewCode;
 use Doctrine\ORM\EntityManager;

class NewLocalAtendimentoService {
    
    protected $connection;
    protected $NewLocalAtendimentoFactory;
    protected $Environment;
    protected $newCode;
    
    public function __construct (EntityManager $entityManager, NewLocalAtendimentoFactory $NewLocalAtendimentoFactory, Environment $Environment, NewCode $newCode) {
        $this->connection                   = $entityManager->getConnection();
        $this->NewLocalAtendimentoFactory   = $NewLocalAtendimentoFactory;
        $this->Environment                  = $Environment;
        $this->newCode                      = $newCode;
    }

    public function getServiceLocal(){
        $operadores = $this->NewLocalAtendimentoFactory->getFactoryLocal();
        return $operadores;
    }
    
    public function getServiceLocalParent(){
        $operadores = $this->NewLocalAtendimentoFactory->getFactoryLocalParent();
        return $operadores;
    }
    
    public function getServiceSector(){
        $operadores = $this->NewLocalAtendimentoFactory->getFactorySector();
        return $operadores;
    }
    
    public function getServiceGroup(){
        $operadores = $this->NewLocalAtendimentoFactory->getFactoryGroup();
        return $operadores;
    }
    
    public function getServiceEmployee($params){
        $operadores = $this->NewLocalAtendimentoFactory->getFactoryEmployee($params);
        return $operadores;
    }
    
    public function getServiceCheckList(){
        $operadores = $this->NewLocalAtendimentoFactory->getFactoryCheckList();
        return $operadores;
    }

    // Insere um novo local de atendimento (assim como na tabela de relação com checklist)
    public function insertServiceLocalAt($nmlocalcliente, $cdcliente, $nrtipolocalcli, $nrlocalclientepai, $nrchecklistpadr, $nrsetor, $dsiconelocal, $dsqrcode, $nrorg, $cdoperinclusao, $nrorginclusao, $dtultatu, $cdoperultatu, $nrorgultatu, $nrgrupolocal, $dscodigolocalcli, $dscoridlocal){
        
        $nrlocalcliente = $this->newCode->getCodeByTableName('FCM_LOCALCLI', $nrorg, 1, 10, true);
        
        $params = array(
            'NRLOCALCLIENTE' => $nrlocalcliente,
            'NMLOCALCLIENTE' => $nmlocalcliente, 
            'CDCLIENTE' => $cdcliente, 
            'NRTIPOLOCALCLI' => $nrtipolocalcli, 
            'NRLOCALCLIENTEPAI' => $nrlocalclientepai, 
            'NRCHECKLISTPADR' => $nrchecklistpadr,
            'NRSETOR' => $nrsetor, 
            'DSICONELOCAL' => $dsiconelocal, 
            'DSQRCODE' => $dsqrcode, 
            'NRORG' => $nrorg,
            'CDOPERINCLUSAO' => $cdoperinclusao,
            'NRORGINCLUSAO' => $nrorginclusao,
            'CDOPERULTATU' => $cdoperultatu, 
            'NRORGULTATU' => $nrorgultatu,          
            'NRGRUPOLOCAL' => $nrgrupolocal,
            'DSCODIGOLOCALCLI' => $dscodigolocalcli,
            'DSCORIDLOCAL' => $dscoridlocal
        );
        $nrrelaclocalchk = $this->newCode->getCodeByTableName('FCM_RELACLOCALCHK', $nrorg, 1, 10, true);
        
        $paramsChk = array(
            'NRRELACLOCALCHK' => $nrrelaclocalchk,
            'NRLOCALCLIENTE' => $nrlocalcliente,
            'NRCHECKLIST' => $nrchecklistpadr
        );
        
        $this->connection->beginTransaction();
        
        try {
            $this->NewLocalAtendimentoFactory->insertFactoryLocalAt($params);
            if ($nrchecklistpadr !== null) $this->NewLocalAtendimentoFactory->insertRelacLocalChk($paramsChk);
            $response = 'Inserido com sucesso';
            
            $this->connection->commit();
        }
       catch(\Exception $e) {
            $this->connection->rollback();
            $response = $e->getMessage();
       }

        return $response;
    }
    
     // Função de inserir tarefa através da tela de criar local
    /*public function insertServiceTask($nrchecklistagend, $nrfuncionario, $dsobstarefaagend, $nrorg, $cdoperinclusao, $nrorginclusao,  $dtultatu, $cdoperultatu, $nrorgultatu){
        
        $nrtarefaagend = $this->newCode->getCodeByTableName('FCM_LOCALCLI', $nrorg, 1, 10, true);
        
        $params = array(
            'NRTAREFAAGEND' => $nrtarefaagend,
            'NRCHECKLISTAGEND' => $nrchecklistagend,
            'NRFUNCIONARIO' => $nrfuncionario,
            'DSOBSTAREFAAGEND' => $dsobstarefaagend, 
            'NRORG' => $nrorg, 
            'CDOPERINCLUSAO' => $cdoperinclusao, 
            'NRORGINCLUSAO' => $nrorginclusao,  
            'DTULTATU' => $dtultatu, 
            'CDOPERULTATU' => $cdoperultatu, 
            'NRORGULTATU' => $nrorgultatu,
            'NRTAREFACHK' => $nrtarefaagend
        );
        try {
            $operadores = $this->NewLocalAtendimentoFactory->insertFactoryLocalAt($params);
        }
       catch(\Exception $e) {
        $this->connection->rollback();
        $response = utf8_decode($e->getMessage());
       }
       
        return $operadores;
    }*/
    
    public function getServiceLocalAtToUpdate($nrlocalcliente){
        $param = array(
            'NRLOCALCLIENTE' => $nrlocalcliente
        );
        
        $operadores = $this->NewLocalAtendimentoFactory->getFactoryLocalAtToUpdate($param);
        return $operadores;
    }
    
    public function updateServiceLocalAt($nrlocalcliente, $cdcliente, $nmlocalcliente, $nrtipolocalcli, $nrlocalclientepai, $nrsetor,  $nrchecklistpadr, $dscodigolocalcli, $dscoridlocal){
        
        $param = array(
            'NRLOCALCLIENTE' => $nrlocalcliente,
            "CDCLIENTE" => $cdcliente,
            'NMLOCALCLIENTE' => $nmlocalcliente, 
            'NRTIPOLOCALCLI' => $nrtipolocalcli, 
            'NRLOCALCLIENTEPAI' => $nrlocalclientepai,
            'NRCHECKLISTPADR' => $nrchecklistpadr,
            'NRSETOR' => $nrsetor,
            'DSCODIGOLOCALCLI' => $dscodigolocalcli,
            'DSCORIDLOCAL'=> $dscoridlocal
        );
        
        $paramsChk = array(
            'NRLOCALCLIENTE' => $nrlocalcliente,
            'NRCHECKLIST' => $nrchecklistpadr,
        );
        $this->connection->beginTransaction();
        
        try{
            $this->NewLocalAtendimentoFactory->updateFactoryLocalAt($param);
            if ($nrchecklistpadr !== null) $this->NewLocalAtendimentoFactory->updateRelacLocalChk($paramsChk);
            
            $this->connection->commit();
            
            $response = 'Editado com sucesso';
        }
        catch(\Exception $e) {
            $this->connection->rollback();
            $response = $e->getMessage();
       }
        return $response;
    }
    // Busca todos os locais
    public function getLocals() {
        $operadores = $this->NewLocalAtendimentoFactory->getLocals();
        return $operadores;
    }
}
?>